/**
 * @file
 * Provides GridStack admin utilities.
 */

(function ($, Drupal) {

  'use strict';

  function process(el) {
    var url = el.dataset.src;
    if (!url) {
      url = el.src;
    }

    if (url && url.indexOf('?') < 0) {
      var date = new Date();
      el.setAttribute('data-src', url + '?rand=' + date.getTime());
    }
  }

  /**
   * Attaches gridstack behavior to HTML element .form--gridstack.
   *
   * @type {Drupal~behavior}
   */
  Drupal.behaviors.gridStackAdminList = {
    attach: function (context) {

      // Context is unreliable with AJAX contents.
      context = context instanceof HTMLDocument ? context : document;

      var elms = context.querySelectorAll('.b-lazy');
      if (elms.length) {
        $.once($.forEach(elms, process, context));
      }

    }
  };

})(dBlazy, Drupal);
